/*
   NAME:        vector.h
   AUTHOR:      root <root@>
   DATE:        Jan 19 1997
   COMMENT:     Vector class
*/
#ifndef VECTORH
#define VECTORH

class Vector {
private:
  float values[3];
public:
  inline Vector() {
    values[0] = values[1] = values[2] = 0.0f;
  };
  inline Vector(float x,float y,float z) {
    values[0] = x;
    values[1] = y;
    values[2] = z;
  };
  inline Vector(float *src) {
    memcpy(values,src,3*sizeof(float));
  };
  inline Vector(Vector &src) {
    memcpy(values,src.array(),3*sizeof(float));
  };
  inline Vector &operator=(Vector src) {
    memcpy(values,src.array(),3*sizeof(float));
    return *this;
  };
  inline float operator[](short index) {
    return values[index];
  };
  inline float *array() {
    return values;
  };
  inline void show(char *s) {
    fprintf(stderr,"+- Vector ------------+\n");
    fprintf(stderr,"| %-10s %8.3f |\n",s,values[0]);
    fprintf(stderr,"|            %8.3f |\n",values[1]);
    fprintf(stderr,"|            %8.3f |\n",values[2]);
    fprintf(stderr,"+---------------------+\n");
  };
};

inline Vector &operator+(Vector A,Vector B) {
  return *(new Vector(A[0]+B[0],A[1]+B[1],A[2]+B[2]));
}

inline Vector &operator-(Vector A,Vector B) {
  return *(new Vector(A[0]-B[0],A[1]-B[1],A[2]-B[2]));
}

inline Vector &operator^(Vector A,Vector B) { // cross
    return *(new Vector(A[1]*B[2]-A[2]*B[1],
			A[2]*B[0]-A[0]*B[2],
			A[0]*B[1]-A[1]*B[0]));
}

inline float operator*(Vector A,Vector B) {
  return (A[0]*B[0]+A[1]*B[1]+A[2]*B[2]);
}


#endif /* VECTORH */
