/*
   NAME:	arrow.h
   AUTHOR:	Ole Gunnar Westgaard TFU <olew@dina>
   DATE:	Dec 17 1996
   COMMENT:	ARROW, ThreeD arrow button
*/
#ifndef ARROWH
#define ARROWH

#include "otools.h"

// ARROW type (defines|(0-15))
#define arSTABLE  0x80         // 3d part doesn't budge
#define arIN      0x40         // 3d border is inwards
#define arFRAME   0x20         // singlepixel bordercolor frame
#define arNOBACK  0x10         // Background is not painted

// ARROW look use oA____ (otools.h) defines!

class ARROW:public FIGLET {
protected:
  COLORSET *set;
  PEN *pen;
  uchar type,arrow,space;                                      // Look of arrow
  int *colors;          // If this is NULL, standard color indexes will be used
public:
  // Will use colors (border,sd,bg,hl,(dk=sd2),(fg=bg2),(lt=hl2)
  ARROW(WINDOW*,int,int,int,int,uchar,uchar,uchar);
  // The last ints are colorindexes (border,sd1,bg1,hl1,sd2,bg2,hl2)
  ARROW(WINDOW*,int,int,int,int,uchar,uchar,uchar,int,int,int,int,int,int,int);
  virtual ~ARROW(void);
  virtual void Refresh(void);
  virtual void Draw(void);
  virtual char Press(uchar,int,int);
  virtual char Motion(uchar,int,int);
  virtual char Release(uchar,int,int);
};


#endif /* ARROWH */
