/*
   NAME:        files.cc
   AUTHOR:      Ole Gunnar Westgaard TFU <olew@dina>
   DATE:        Mar 25 1997
   COMMENT:     Implementation of file-dialog
*/

#include "files.h"
#include "button.h"
#include "frame.h"
#include "input.h"

class FILEITEM : public FIGLET {
public:
  FILEITEM(WINDOW *w,char*,ushort atr,uchar type) : FIGLET(w,0,0,0,0)
  {
  };
  ~FILEITEM(void)
  {
  };
};

FILEDIALOG::FILEDIALOG(COLORSET *cst,int x,int y,int w,int h,
		       char *tit,char *,char *,int ,uchar bw,
		       uchar opt,char *font)
{
  COLORSET *cs;  
  FRAME *frame;
  /*
char WINDOW::Create(DISPLAY *_dp,COLORMAP *_mp,COLORSET *_cs,Window _pt,
		    char *_tt,char *_it,int _xp,int _yp,int miw,int mih,
		    int inw,int inh,int maw,int mah,int _bw,uchar *_ic,
		    uint _iw,uint _ih,char *_fn,int _dt,Visual *_vs,uchar _mt)
		    */
 
  if (!Create(cst->cmap()->dpy(),cst->cmap(),cst,0,tit,tit,x,y,w,h,
	      w,h,w,h,0,NULL,0,0,font,0,NULL,0))
    return;
  display->Add(this);
  cs = new COLORSET(display->cmap(),
		    "black:#242:#474:#6a6:white:black:yellow");

  frame = new FRAME(this,3,-35,-4,-4,fIN|fSNG,2,0);
  frame->Stacking(4,1,1,1,2,2);

  frame->Add(new BUTTON(this,cs,0,0,0,0,"Open",0,butMOVEDARK|2,0,this));
  frame->Add(new BUTTON(this,cs,0,0,0,0,"Cancel",0,butMOVEDARK|2,0,this));
  frame->Add(new BUTTON(this,cs,0,0,0,0,"new file",0,butMOVEDARK|2,0,this));
  frame->Add(new BUTTON(this,cs,0,0,0,0,"new dir",0,butMOVEDARK|2,0,this));

  frame = new FRAME(this,3,32,-4,-39,fIN|fSNG,2,0);
  frame->Stacking(2,7,1,1,1,1);

  for (int i=0; i<14; i++)
    frame->Add(new INPUT(this,NULL,NULL,0,0,0,0,NULL,2,NULL,NULL));

  new INPUT(this,NULL,NULL,3,3,-4,28,NULL,2,NULL,NULL);
}

FILEDIALOG::~FILEDIALOG(void)
{
}

void FILEDIALOG::show(void)
{
  XMapWindow(display->xdpy(),window);
  Refresh(0,0,width,height);
}

void FILEDIALOG::hide(void)
{
  XUnmapWindow(display->xdpy(),window);
}

char FILEDIALOG::Trigger(ELEMENT*)
{
  hide();
  return 0;
}
