/*
   NAME:        files.h
   AUTHOR:      Ole Gunnar Westgaard TFU <olew@dina>
   DATE:        Mar 25 1997
   COMMENT:     Implementation of file-dialog
*/
#ifndef FILESH
#define FILESH

#include "otools.h"

class FILEDIALOG : public WINDOW {
public:
  FILEDIALOG(COLORSET *cst,                 // colorset,
	     int x,int y,int w,int h,       // x,y,width,height,
	     char *tit,char *act,char *wcd, // title,action_button,wildcards,
	     int lin,uchar bw,uchar opt,    // lines,border_width,options
	     char *font);
  ~FILEDIALOG(void);
  void show(void);
  void hide(void);
  char Trigger(ELEMENT *element);
protected:

};

/*
  new FILES(window,colorset,x,y,w,h,title,action,path,wildcards,
            lines,options);

  +---------------------------------------------------+
  | "File Dialog: Open Dovre Model Files"         _ X |
  +---------------------------------------------------+
  | /------------------------------\ /--------------\ |
  | | Filename.tggg_               | | *.rwx;*.dmf  | |
  | \------------------------------/ \--------------/ |
  | +-----------------------------------------------+ |
  | | ../      katalog3/                            | |
  | | avatar/  man3/                                | |
  | | bin/     runner*                              | |
  | | bmp/     game*                                | |
  | | city/    link@                                | |
  | | fonts/   linux@                               | |
  | | olew/    koko.rwx                             | |
  | | scenes/  koko.dmf                             | |
  | | sound/                                        | |
  | | tsahl/                                        | |
  | | vrnt/                                         | |
  | | worlds/                                       | |
  | | olemann/                                      | |
  | +-----------------------------------------------+ |
  | +----------+ +---------+ +---------+ +----------+ |
  | |  "Open"  | | Cancel  | | Makedir | | Makefile | |
  | +----------+ +---------+ +---------+ +----------+ |
  +---------------------------------------------------+

  Pressing left button opens attributes window:

  new ATTRIBUTES(window,colorset,filepath);

  +--------------------------------+
  | File Attributes            _ X |
  +--------------------------------+
  | Path: /koko/maksdm/asdad/sada  |
  |                                |
  |          user group others     |
  | read       o    o     o        |
  | write      o    o     o        |
  | execute    o    o     o        |
  | s-bit      o    o     X   +----+
  |                           | OK |
  +---------------------------+----+

  Pressing right button selects the file(s).

 */

/*
class ATTRIBUTES : public WINDOW {
public:
protected:
};

class FILELIST : public FIGLET {
  // files - first character is a byte describing the filetype
  // bit 7  readable for user ?
  //     6  writable for user ?
  //     5  executable for user ?
  //     4  userdefined filetype (defined by icons and color)
  //   3-0   0 Disabled file
  //         1 Normal file (unknown filetype)
  //         2 Directory
  //         3 Executable file
  //         4 Symbolic link
  //         5 Special file (devices etc.)
  //         6 Document (text,postscript,html)
  //         7 Picture (ppm,xpm,xbm,gif,jpg,jpeg)
  //         8 Movie (mpeg,avi,mov)
  //         9 Sound (wav,au,mp3,mp2,aiff)
  //        10 Source file (c,cc,cpp,pl)
  //        11 Library file (lib,so,a)
  //        12 3d format file (vrml,wrl,dxf,dwg,rwx,dmf)
  //        13 
  //        14 
  //        15 

  // Original icons are 32x32 pixels, the icon may be scaled both ways.

public:
  FILELIST(WINDOW *w,COLORSET *cs,PEN *pn, // window,colorset,pen
	   int a,int b,int c,int d,        // size
	   char **fs);                     // files
  ~FILELIST(void);
  int widest_filestring(void);             // Width of widest filestring
  void Refresh(void);                      // Refresh whole window
protected:
  char    **files;                         // Buffer of files..
  PEN      *pen;                           // Drawing and font
  COLORSET *set;                           // The colors
};
*/
  
#endif /* FILESH */
