/*
   NAME:	input.h
   AUTHOR:	Ole Gunnar Westgaard TFU <olew@dina>
   DATE:	Jul 16 1996
   COMMENT:	INPUT figlet, keyboard input
*/
#ifndef INPUTH
#define INPUTH

#include "otools.h"

// options (+width)
#define inFOCUS          0x80
#define inOVERWRITE      0x40
#define inCLICKTOFOCUS   0x20
#define inDARKBACKGROUND 0x10
// width = 0-15 (1-16)

class INPUT : public FIGLET {
protected:
  PEN *pen;
  COLORSET *set;
  uchar options;
  char (*cb_function)(INPUT*,char*); // return 1 = clear the buffer
  ELEMENT *cb_element; // Trigger(), return 1 = clear the buffer
  char *string; // string, dynamic allocation
  ulong stringsize,cursor,stringstart;
public:
  // window,xa,ya,xb,yb,text,element,callback
  INPUT(WINDOW*,COLORSET*,PEN*,int,int,int,int,char*,uchar,
	ELEMENT*,char(*)(INPUT*,char*));
  virtual ~INPUT(void);
  virtual void String(char*);                                 // Set the string
  virtual void Refresh(void);
  virtual void DrawFocus(void);
  virtual void DrawText(void);

  virtual char Motion(uchar,int,int);                  // Pointer inside figlet
  virtual char Press(uchar,int,int);                          // button pressed

  virtual char Focus(FIGLET*);                   // Figlet has been given focus
  virtual void DeFocus(FIGLET*);                   // Figlet has been defocused
  virtual char Input(char*);                          // Text from the keyboard
};

#endif /* INPUTH */
