/*
   NAME:        opengl.h
   AUTHOR:      root <root@>
   DATE:        May  8 1997
   COMMENT:     OpenGL window (RGB mode, ready for OpenGL commands)
*/

#ifndef OPENGLH
#define OPENGLH

#include "otools.h"

#ifndef byte
#define byte unsigned char
#endif

#ifndef word
#define word unsigned short
#endif

#ifndef dword
#define dword unsigned int
#endif

class OPENGLWINDOW : public WINDOW {
public:
  OPENGLWINDOW(DISPLAY*,int,int,int,int,int,int,int,int,char*);
  void values(float,float,float);
  void rotate(void);
  void redraw(void);
  void Size(void);
  char Trigger(ELEMENT*);
  void Refresh(int,int,int,int);
private:
  Colormap mycolormap;
  float yaw,pitch,roll;
};

#define FLATSHADED 0
#define GOURAUD    1

class Material {
public:
  float color[3],surface[3];
  byte  options;
  Material(float r,float g,float b,float a,float s,float d,byte o);
  void setColor(float red,float green,float blue);
  void setSurface(float ambient,float specular,float diffuse);
  void setOptions(byte o);
  void activateMaterial(void);
  void changeFromMaterial(Material *m);
};

class Vertex {
public:
  float position[3];
  Vertex(float x,float y,float z);
  virtual void process(void);
};

class NVertex : public Vertex{
public:
  float normal[3];
  NVertex(float x,float y,float z,float e,float f,float g);
  virtual void process(void);
};

class Polygon {
public:

};

#endif /* OPENGLH */
