/*
   NAME:	scroll.h
   AUTHOR:	Ole Gunnar Westgaard TFU <olew@dina>
   DATE:	Jul 23 1996
   COMMENT:	SCROLL figlet
*/
#ifndef SCROLLH
#define SCROLLH

#include "otools.h"
#include "defines.h"

/*
  type: 
        +------+          +--+         +--+
        |**    | oLEFT    |**|         |  |
        +------+          |  | oTOP    |**| oMIDDLE
        |    **| oRIGHT   |  |         |  |
        +------+          +--+         +--+
        |  **  | oMIDDLE  |  |         |**|
        +------+          |  | oBOTTOM |**| oVWIDE
        |******| oHWIDE   |**|         |**|
        +------+          +--+         +--+

	bit 6,7 = horizontal alignment
        bit 4,5 = vertical alignment

  The button will cover a floating point range vertically and horisontically.
  The Range is defined from start to end, with an increment. Also the
  horisontal and vertical positions are given initially. 

 */

class SCROLL:public FIGLET {
protected:
  PEN *pen;
  COLORSET *set;
public:
  // window,xa,ya,xb,yb,title,type,border,
  SCROLL(WINDOW*,int,int,int,int,char*,uchar,uchar
};


#endif /* SCROLLH */
