/*
   NAME:	selector.h
   AUTHOR:	Ole Gunnar Westgaard TFU <olew@dina>
   DATE:	Feb  5 1997
   COMMENT:	Simple interface to select a string among strings
*/
#ifndef SELECTORH
#define SELECTORH

#include "otools.h"

class SELECTOR : public FIGLET {
protected:
  PEN      *pen;
  COLORSET *set,*tes;
  char     *list,pressed,looping;
  int       width,number,max;
public:
                SELECTOR(WINDOW*,int,int,int,int,char*,char);
  virtual      ~SELECTOR(void);
  virtual void  Refresh(void);
  virtual void  DrawArrows(void);
  virtual void  Draw(void);
  virtual char  Press(uchar,int,int);
  virtual char  Motion(uchar,int,int);
  virtual char  Release(uchar,int,int);
  virtual void  SetList(char*);
  virtual void  SetNumber(int);
  virtual int   GetNumber(void);
  virtual void  GetString(char*,int);
  virtual void  Next(void);
  virtual void  Previous(void);
};

#endif /* SELECTORH */
