/*
   NAME:        xgmod.cc
   AUTHOR:      olew@ifi.uio.no
   DATE:        Feb  4 1997
   COMMENT:     Xinterface for gmod
*/

#include <stdio.h>
#include "otools.h"
#include "figlets.h"
#include "xgmod.xbm"

DISPLAY *dpy;
WINDOW  *wnd;

class SYMBOLBUTTON : public FIGLET {
private:
  PEN      *pen;
  COLORSET *set;
public:
  SYMBOLBUTTON(WINDOW *w,int a,int b,int c,int d)
    : FIGLET(w,a,b,c,d) {
    pen = window->dpen();
    set = window->cset();
    window->Add(this);
    window->Activate(this);
  };
  ~SYMBOLBUTTON(void) {
    window->DeActivate(this);
    window->Del(this);
  };
};

char Quit(BUTTON*)
{
  dpy->Stop();
  return 0;
}

int main(int,char**)
{ 
  int height;
  dpy = new DISPLAY(NULL);
  if (!dpy->xdpy()) return -1;

  COLORSET *cs = new COLORSET(dpy->cmap(),
			      "#000:#466:#688:#8cc:#000:#000:#ff0");

  wnd = new WINDOW(cs,"Xgmod","7x13bold",10,10,200,49,
		   xgmod_bits,xgmod_width,xgmod_height);
  if (!wnd->dpy()) return -2;
  
  (new BUTTON(wnd,  2,2, 45,24,"Quit",butFRAME,2,0,NULL))->Callback(Quit);
  new BUTTON(wnd, 47,2, 90,24,"Play",butFRAME,2,0,NULL);
  new BUTTON(wnd, 92,2,135,24,"Stop",butFRAME,2,0,NULL);
  new BUTTON(wnd,137,2,170,24,"FFW",butFRAME,2,0,NULL);
  new BUTTON(wnd,172,2,198,24,"RWD",butFRAME,2,0,NULL);

  height = 33+wnd->dpen()->Descent()+wnd->dpen()->Ascent();
  
  new SELECTOR(wnd,2,26,197,height,
	       "Running away with you...\nHalloween is coming\nRun run away!!!\nOver the top\nDownhill from here",1);

  // wnd->Resize(200,height+2);

  /*
  new INPUT(&window,
	    110,3,595,32,
	    "Add:",inSUNKEN|inRIGHT|2,inSHADOW|2,2,oLEFT|2,oLEFT|2,addline,0);
	    */

  dpy->EventLoop();


  delete cs;
  delete dpy;

  return 0;
}
