/*
   NAME:        one.cc
   AUTHOR:      root <root@ogware>
   DATE:        Apr 16 1997
   COMMENT:     
*/

#include <stdio.h>
#include "otools.h"
#include "figlets.h"

#ifdef OPENGL
#include "opengl.h"
OPENGLWINDOW *oglw;
#endif

char Quit(BUTTON*)
{
  otools.Stop();
  return 0;
}

void Slide(SLIDER*,float h,float v)
{
#ifdef OPENGL
  oglw->values(-v*360.0,h*360.0,0.0);
#endif
}

int main(int,char**)
{
  DISPLAY display(NULL);
  COLORSET colorset(display.cmap(),
		    "black:#432:#864:#fb8:black:blue4:yellow:green:red:cyan");
  WINDOW window(&colorset,"Application","7x13",50,50,120,140);

  SLIDER slider(&window,5,5,-6,90,0,sSNG,1,4,4,0,0.0,0.0,
		Slide);

  BUTTON button(&window,5,-40,-6,-6,"Quit",butFRAME|butBORDER|2,2,0,0);
  button.Callback(Quit);

#ifdef OPENGL
  oglw = new OPENGLWINDOW(&display,10,10,20,20,100,100,600,600,
			  "black:gray30:gray60:gray90:black:yellow:blue");

  otools.Timer(oglw,5); // Run Trigger() on oglw every five seconds...
#endif

  otools.EventLoop();

  return 0;
}
