#!/usr/bin/perl

$ver = `cat version`;
$body = `grep "<body" html/index.html`;
chop($ver);

print "<html><head><title>Otools version $ver classes</title></head>\n";
print $body;
print "<a href=\"index.html\"><img border=0 src=\"back.gif\"></a>\n";
print "<a href=\"http://rosa.nta.no/~olew/otools/\">\n";
print "<img border=0 alt=\"Otools\" src=\"otools.gif\" align=bottom></a>\n";
print "<b>classes</b><hr>\n";

$normal = "";
$italic = "";
$source = "";
$predos = "";

while (<>) {
    if (/^\s*class.+\{\s+/) {
	&doclass;
    }
}

print "</ul>\n<h6><hr>This overview is created automatically";
print " from the headerfiles</h6>\n";
print "</body></html>\n";

sub doclass {
    ($class,$pub) = $_ =~ /class\s+([^ :]+)([^\{]*)\{/;

    print "<li> class <a href=\"classes/$class.html\">$class</a>\n";

    open(OUT,">html/classes/$class.html");

    print OUT "<html><head><title>Otools version $ver class $class</title></head>\n";
    print OUT $body;
    print OUT "<a href=\"../index.html\"><img border=0 src=\"../back.gif\"></a>\n";
    print OUT "<a href=\"http://rosa.nta.no/~olew/otools/\">\n";
    print OUT "<img border=0 alt=\"Otools\" src=\"../otools.gif\" align=bottom></a>\n";
    print OUT "<b>class $class $pub</b><hr>\n";
    
    #print OUT "<html><head><title>Otools v$ver class $class</title>";
    #print OUT "</head><body>\n";
    #print OUT "<h2><a name=\"$class\">class $class $pub</h2><hr><ul>\n";

    $public = 0;
    $startsource = 0;

    while (! (/^\s*\};/)) {
	# Collect whole section before writing...
    
	if (/^\s*\/\/[.\/>]\s+/) {
	    # get what, remove wrapper
	    ($what) = $_ =~ /^\s*\/\/(.)/;
	    s/^\s*\/\/.\s//;
	    chop;
	    s/\s+$//;

	    if ($what eq ">") {
		# <pre> text will be placed in a centered table
		&flush_normal;
		&flush_source;
		&flush_italic;
		$predos .= "$_\n";
	    }

	    elsif ($what eq "/") {
		# Normal comments, flush source / italic, add to normal
		&flush_predos;
		&flush_source;
		&flush_italic;
		if (/^\s*$/) {
		    $normal .= "<br>\n";
		} else {
		    $normal .= " " . $_;
		}
	    }

	    elsif ($what eq ".") {
		# Italic comments flush normal / source, add to comment
		&flush_predos;
		&flush_normal;
		&flush_source;
		if (/^\s*$/) {
		    $italic .= "<br>\n";
		} else {
		    $italic .= " " . $_;
		}

	    }
    

	} elsif ($public) { # We are in the public section
	    # Remove wrappers and lousy comments
	    s/\s*\/\/.*$//;
	    s/inline//;
	    s/virtual/<i>virtual<\/i>/;
	    s/^\s+//;
	    &flush_predos;
	    &flush_normal;
	    &flush_italic;
	    s/(\S),(\S)/\1, \2/g;
	    if (/\(/) {
		$startsource = 1;
		&flush_source;
		$source .= " " . $_;
	    } elsif (/\)/) {
		$source .= " " . $_;
		&flush_source;
		$startsource = 0;
	    } elsif ($startsource) {
		$source .= " " . $_;
	    }
    	}

	$_=<>;
	if (/public:/) {
	    $public = 1;
	    &fall;
	    print OUT "<ul>\n";
	}
	elsif (/private:/) {
	    if ($public) {
		$public = 0;
		&fall;
		print OUT "</ul><p>\n";
	    }
	}
	elsif (/protected:/) {
	    if ($public) {
		$public = 0;
		&fall;
		print OUT "</ul><p>\n";
	    }
	}
    }
    &fall;
    if ($public) { print OUT "</ul>\n"; }
    print OUT "</ul><hr></body></html>\n";
 
    close(OUT);
   
}

sub fall {
    &flush_predos;
    &flush_source;
    &flush_italic;
    &flush_normal;
}

sub flush_source {
    if ($source ne "") {
	print OUT "<b>$source</b><br>\n";
	$source = "";
    }
}

sub flush_predos {
    if ($predos ne "") {
        $predos =~ s/[\n \t\r]+$//;
	print OUT "<center><table border=1>\n";
	#print OUT "<tr><td><center>Example</center></td>\n";
	print OUT "<tr><td><pre>";
	print OUT "$predos</table></center><p>";
	$predos = "";
    }
}

sub flush_normal {
    if ($normal ne "") {
	&links;
	print OUT "$normal<p>\n";
	$normal = "";
    }
}

sub flush_italic {
    if ($italic ne "") {
	&links;
	print OUT "<i>$italic</i><br><br>\n";
	$italic = "";
    }
}

sub links {
    $normal=~s/(class\s+)([ABCDEFGHIJKLMNOPQRSTUVWXYZ]+)/<a href="\2.html">\1\2<\/a>/g;
    $italic=~s/(class\s+)([ABCDEFGHIJKLMNOPQRSTUVWXYZ]+)/<a href="\2.html">\1\2<\/a>/g;
    $normal=~s/\s(\S+\.gif)/\n<center><img src=\"\1\"><\/center>/g;
}

