#!/local/bin/perl

# COLORS http://www.ifi.uio.no/~olew/bgblue.jpg #AAAAFF #1020d0 #FF8888 #60C044

require ".lib.cgi";
require ".html.cgi";

$pb = "<a href=\".fa.cgi?";
$pc = "\">";
$pe = "</a>";

$hb = "<a href=\"";
$hc = "\">";
$he = "</a>";

$level = 0;
$borderwidth = 1;

$ENV{PATH} = "/usr/local/bin:" . $ENV{PATH};

($document) = $ENV{QUERY_STRING}; #  =~ /(.*)\.fa$/;

if ($0 =~ /in165\.cgi/) {
    $pb = "<a href=\".in165.cgi?";
    $document = "in165/" . $document;
    $in165mode = 1;
} else {
    $in165mode = 0;
}

if ($document =~ /\.faa/) { # Wether we want an abstract or not
    $document =~ s/\.faa/\.fa/;
    $abstract = 1;
} else {
    $abstract = 0;
}


if ($document =~ /.*\.fa\.gz$/) {
    if (!open(IFA,"gunzip -c $document|")) {
	&top("Error: $document","#660000","#ffff00","#FFFF00","#0000DD");
	print "Kan ikke finne dokument '$document'!!\n";
	$data = "";
	&Level(0);
	print $data;
	&hr;
	&bottom;
	exit(0);
    }
} else {
    if (!open(IFA,$document)) {
	&top("Error: $document","#660000","#ffff00","#FFFF00","#0000DD");
	print "Kan ikke finne dokument '$document'!!\n";
	$data = "";
	&Level(0);
	print $data;
	&hr;
	&bottom;
	exit(0);
    }
}

# Fetch page setup data

$_ = <IFA>;

$color_fg = "#dddddd";
$color_bg = "#000000";
$color_ln = "#FF0000";
$color_fo = "#0000FF";

while (/^\s*\#/) {
    s/^\s*\#//;
    if (/^COLOR[s]*/i) {
	s/^COLOR[s]*\s*//i;
	($color_fg,$color_bg,$color_ln,$color_fo) =
	    $_ =~ /(\S+)\s+(\S+)\s+(\S+)\s+(\S+).*/;
    }
    elsif (/^BORDERW*I*D*T*H*\s+\d+/) {
	($borderwidth) = $_ =~ /\S+\s+(\d)+/;
    }
    $_ = <IFA>;
}

# Print header
if ($abstract) {
    &top("Abstract: $document","#888888","#000000","#FFFF00","#0000DD");
} else {
    &top("Document: $document",$color_fg,$color_bg,$color_ln,$color_fo);
}

$more = 0;

$running = 1;

while ($running) {


    if ($more) {
	$_=<IFA>;

    } else {
	$more=1;
    }

    $data = "";

    if ($abstract) { # Collect an abstract from the chapters

	if ((/^\d/) || (/^  \d/) || (/^    \d/) || (/^      \d/)) {
	    $uls = 0;
	    while (/^  /) { $uls++; s/^  //; }
	    ($kap,$tit) = $_ =~ /([0123456789,.]+)\s+(.*)/;
	    
	    $u=0;
	    while ($u < $uls) {
		$data .= "<ul>";
		$u++;
	    }

	    if ($uls == 0) {
		$data .= "<h2>$pb$document#kapittel $kap$pc";
		$data .= "$kap $tit$pe</h2>";
	    } elsif ($uls == 1) {
		$data .= "<b>$pb$document#kapittel $kap$pc";
		$data .= "$kap $tit$pe</b>";
	    } else {
		$data .= "$pb$document#kapittel $kap$pc";
		$data .= "$kap $tit$pe";
	    }

	    $u=0;
	    while ($u < $uls) {
		$data .= "</ul>";
		$u++;
	    }
	    $data .= "\n";

	}

    }

    elsif (/^\s*#/) {                                   # Ignore comments
        $_ =~ s/\n*\r*//g;
        if (/^#BORDERW*I*D*T*H*\s+\d+/) {
            ($borderwidth) = $_ =~ /\S+\s+(\d)+/;
        }
        $data = "<!-- $_>\n";
        $more = 1;
    }

    elsif (/<PRE>/i) { 					# <PRE>
	print "<pre>\n";
	$_ = <IFA>;
	while (!(/<\/PRE>/i)) {
	    print;
	    $_ = <IFA>;
	}
	print "</pre>\n";
    }
    
    elsif (/^ *\n$/) {					 # <P>
	while (/^ *\n$/) {
	    $_ = <IFA>;
	}
	$data = "<p>\n";
	$more = 0;
    }
    
    elsif (/^ *-+ *\n$/) {					# <HR>
	if (/^ \S/) { &Level(0); }
	elsif (/^   \S/) { &Level(1); }
	elsif (/^     \S/) { &Level(2); }
	$data .= "<hr>\n";
    }
    
    elsif (/^\S/) {						# <H1>
	&Level(0);
	$data .= "<h1>";
	while (/^\S/) {
	    chop;
	    $data .= $_ . " ";
	    $_ = <IFA>;
	}
	$data .= "</h1>\n";
	$more = 0;
    }
    
    elsif (/^  \S/) {					# <H2>
	&Level(1);
	$data .= "<h2>";
	while (/^  \S/) {
	    chop;
	    s/^  //;
	    $data .= $_ . " ";
	    $_ = <IFA>;
	}
	$data .= "</h2>\n";
	$more = 0;
    }
    
    elsif (/^    \S/) {					# <H3><B>
	&Level(2);
	$data .= "<h2>";
	while (/^    \S/) {
	    chop;
	    s/^    //;
	    $data .= $_ . " ";
	    $_ = <IFA>;
	}
	$data .= "</h2>";
	$more = 0;
    }
 
    elsif (/^      \S/) {				# <H3><B>
	&Level(3);
	$data .= "<h3><b>";
	while (/^      \S/) {
	    chop;
	    s/^      //;
	    $data .= $_ . " ";
	    $_ = <IFA>;
	}
	$data .= "</b></h3>";
	$more = 0;
    }
    
    elsif (/^        \S/) {				# <H3><B>
	&Level(0);
	$data .= "<h2 align=center>";
	while (/^        \S/) {
	    chop;
	    s/^        //;
	    $data .= $_ . " ";
	    $_ = <IFA>;
	}
	$data .= "</h2>";
	$more = 0;
    }
    
    elsif (/\t/) {                     			# <TABLE>
	$data .= "<table border=$borderwidth>\n";
	while (/\t/) {
	    chop;
	    s/\t+/<\/td><td>/g;
	    $data .= "<tr><td>" . $_ . "</td>\n";
	    $_ = <IFA>;
	}
	$data .= "</table><p>\n";
	$more = 0;
    }
    
    elsif (/^ * - \S/) {					# <LI>
	$data .= "<ul>";
	$lidown = 0;
	while (/^ +[- ] \S+/) {
	    s/\n//g;
	    s/^ +-/\n<li>/;
	    s/^  ( +)([^-])/<br>\n\1\2/;
	    $data .= $_;
	    $_ = <IFA>;
	}
	$data .= "\n</ul>\n";
	$more = 0;
    }
    
    elsif (/^\s+\S/) {

	if ($in165mode) {
	    if (/^ \S/) { &Level(1); $data .= $_; }
	    elsif (/^   \S/) { &Level(2); $data .= $_; }
	    elsif (/^     \S/) { &Level(3); $data .= $_; }
	    elsif (/^       \S/) {
		&Level(0);
		$data .= "<p align=center>\n ";
		while (/^       \S/) {
		    $data .= $_;
		    $_ = <IFA>;
		}
		$data .= "<p>\n";
		$more = 0;
	    }
	} else {
	    if (/^ \S/) { &Level(1); $data .= $_; }
	    elsif (/^   \S/) { &Level(2); $data .= $_; }
	    elsif (/^     \S/) { &Level(3); $data .= $_; }
	    elsif (/^       \S/) { &Level(4); $data .= $_; }
	    elsif (/^         \S/) {
		&Level(0);
		$data .= "<p align=center>\n ";
		while (/^         \S/) {
		    $data .= $_;
		    $_ = <IFA>;
		}
		$data .= "<p>\n";
		$more = 0;
	    }
	}
    }
    
    else { $data = $_; }					# text
    
    if (!$abstract) {
	&Links;							# links
    }
    
    $data =~ s/  / /g;
    $data =~ s/ & / &amp; /g;
    $data =~ s/ < / &lt; /g;
    $data =~ s/ > / &gt; /g;
    $data =~ s/ -> / -&gt; /g;
    $data =~ s/ <-> / &lt;-&gt; /g;

    print $data;						# print
    
    if (eof) { $running = 0; }
    if (!$more) { $running = 1; }
}
 
close(IFA);

$data = "";
&Level(0);
print $data;
&hr;
&bottom;

sub Links {
  $data =~ s/_+([^_]+)_+/<b>\1<\/b>/g;            	# _bold faced text_
  $data =~ s/"([^_]+)"/"<i>\1<\/i>"/g;          	# "quotes"
  $data =~ s/'([^_]+)'/<i>\1<\/i>/g;            	# 'italic text'

  $data =~ s/(<h\d><*b*>* *)([0123456789,.]+)/<a name="kapittel \2">\1\2/gi;

  $data =~ s/(s*e*) (seksjon\S* *o*m*) ([01234567890,.]+)/<a href="#kapittel \3">\1 \2 \3<\/a>/gi;

  if (! $in165mode) {
      $data =~ s/(s*e*) ([Kk]apittel\S* *o*m*) ([01234567890,.]+)/<a href="#kapittel \3">\1 \2 \3<\/a>/gi;
      $data =~ s/\[(.*\.fa)\]/\[$pb\1$pc\1$pe\]/g;
      $data =~ s/\[(.*\.html)\]/\[$hb\1$hc\1$he\]/g;
      $data =~ s/\[(.*\/)\]/\[$hb\1$hc\1$he\]/g;
      $data =~ s/\[(.*\w)\]/\[$hb\1$hc\1$he\]/g;
  }

  $data =~ s/-------*/<hr>/g;

  $data =~ s/\((figur [0123456789.]*)\)/<a name="\1">\1/gi;
  $data =~ s/(se) (figur [0123456789.]*)/<a href="#\2">\1 \2<\/a>/gi;

  $data =~ s/\((\S*\.gif)\)/<br><img src="\1"><br>/gi;
  $data =~ s/\((\S*\.jpe*g)\)/<br><img src="\1"><br>/gi;

  $data =~ s/\[(\S*\.gif)\]/<img src="\1" align=left>/gi;
  $data =~ s/\[(\S*\.jpe*g)\]/<img src="\1" align=left>/gi;

  $data =~ s/(se dokume\S* *o*m*) ([^(]+) \((.*)\.fa\)/\1 $pb\3\.fa$pc\2$pe/gi;
  $data =~ s/(refer\S* *a*v*) ([^(]+) \((.*)\.fa\)/\1 $pb\3\.fa$pc\2$pe/gi;
  $data =~ s/(se *\S* side\S*) ([^(]+) \((.*)\.fa\)/\1 $pb\3\.fa$pc\2$pe/gi;
  $data =~ s/(tilbake til) ([^(]+) \((.*)\.fa\)/\1 $pb\3\.fa$pc\2$pe/gi;

  $data =~ s/(se do\S* *o*m*) ([^<(]+) \((.*)\)/\1 $hb\3$hc\2$he/gi;
  $data =~ s/(se *\S* sid\S*) ([^<(]+) \((.*)\)/\1 $hb\3$hc\2$he/gi;
  $data =~ s/(tilbake til) ([^<(]+) \((.*)\)/\1 $hb\3$hc\2$he/gi;


}

sub Level {
    local ($l) = @_;
    if ($l > $level) {
	while ($l > $level) {
	    $data .= "<ul>";
	    $level++;
	}
    } else {
	while ($l < $level) {
	    $data .= "</ul>";
	    $level--;
	}
    }
}

sub AddLevel {
    $data .= "<ul>";
    $level++;
}

sub SubLevel {
    $data .= "</ul>";
    $level--;
}
